
-- spell ids

    dsID = 77606;
    dsName = "";

-- control variables

	movable = false;
	fadetime = 4; -- in seconds
	fadedmg = 10; -- in percent

	SimulacrumDB = {
		alpha = 1.0;
		scale = 1.0;
	}

-- OnLoad

    function Simulacrum_OnLoad()

		local playerClass, englishClass = UnitClass("player");
		if englishClass == "DEATHKNIGHT" then

            SimulacrumFrame:RegisterEvent("UNIT_AURA");

            SimulacrumFrame:RegisterEvent("ADDON_LOADED");

            SimulacrumFrame:EnableMouse(false);

            dsName = GetSpellInfo(dsID);
            print("Addon loaded... "..dsName);

		end

		SimulacrumFrame:Hide();

    end

-- OnEvent

    function Simulacrum_OnEvent(event, arg1, ...)

        if(event=="UNIT_AURA")then

            local name = UnitBuff("player", dsName);
            
            if (name ~= nil) then
            
            	local texture = GetSpellTexture(dsID);
            	setIcon(true, texture);
            
            else
            
            	setIcon(false, nil);
            
            end

        elseif(event=="ADDON_LOADED" and arg1 == "Simulacrum")then

			SimulacrumFrame:SetAlpha(SimulacrumDB.alpha);
			SimulacrumFrame:SetScale(SimulacrumDB.scale);

        end
    end
    
-- IconChange

	function setIcon(visible, texture)
	
		if (visible) then
			local backdrop = SimulacrumFrame:GetBackdrop();
			backdrop.bgFile = texture;
			SimulacrumFrame:SetBackdrop(backdrop);
			SimulacrumFrame:Show();
		else
			SimulacrumFrame:Hide();
		end
	
	end

-- Register chat commands

    SLASH_Simulacrum1, SLASH_Simulacrum2 = '/simulacrum', '/ds';

    local function handler(msg, editbox)
    	local command, rest = msg:match("^(%S*)%s*(.-)$");
    	local value = tonumber(rest);
        if command == 'lock' then
        	if (movable) then
        		movable = false;
        		SimulacrumFrame:Hide();
				SimulacrumFrame:EnableMouse(false);
				print('Frame locked!');
        	else
        		movable = true;
        		SimulacrumFrame:Show();
        		SimulacrumFrame:EnableMouse(true);
        		print('Frame unlocked!');
        	end
        elseif command == 'alpha' then
        	if value >= 0 and value <= 1 then
	       		SimulacrumFrame:SetAlpha(value);
	           	print('Alpha set to '..value);
        		SimulacrumDB.alpha = value;
        	end
        elseif command == 'scale' then
        	if value >= 0.1 and value <= 3 then
        		SimulacrumFrame:SetScale(value);
        		print('Scale set to '..value);
        		SimulacrumDB.scale = value;
        	end
        end
    end
    SlashCmdList["Simulacrum"] = handler;